/*

Cool Array                             by Graeme Pyle (April 1998)
----------

(solution to chapter 6, problem 2)
	
provides useful functions for an array of integers

*/

import java.util.*;

class CoolArray {
	
	final static int[] data={10,9,8,7,6,5,4,3,2,1};
	final static int level=5;
		
	final static int MAX=0;
	final static int MIN=1;

	static int maximum(int[] data) {
		
		int max=0;
		
		for (int i=0; i < data.length; i++)
			if (data[i]>max | i==0)
				max=data[i];
				
		return max;
	}
	
	static boolean equal(int[] data) {
		
		for (int i=1; i < data.length; i++)
				
			if (data[i]!=data[i-1])
				return false;
				
		return true;		
	
	}
	
	static int elementsAbove(int[] data, int level) {
		
		int count=0;
	
		for (int i=0; i < data.length; i++)
			if (data[i]>level)
				count++;
				
		return count;		
	
	}
	
		
	static Vector occurancesOfElement(int[] data, int max) {
		Vector result=new Vector();
		
		for (int i=0; i < data.length; i++)
			if (data[i]==max)
				result.addElement(new Integer(i));
				
		return result;
		
	}
	
	static int[] range(int[] data) {
		
		int[] result=new int[2];
		
		result[MAX]=result[MIN]=data[0];
		
		for (int i=0; i < data.length; i++) {
			if (data[i]>result[MAX])
				result[MAX]=data[i];
			if (data[i]<result[MIN])
				result[MIN]=data[i];
		}
		
		return result;
			
	}

	public static void main(String[] args) {
		
		System.out.print("data = ");
		for (int i=0; i<data.length; i++)
			System.out.print(data[i]+" ");
		System.out.println();			
	
		System.out.println("maximum = "+maximum(data));
		System.out.println("all elements equal = "+equal(data));
		System.out.println("number of values above "+level+" = "+elementsAbove(data,level));

		int max=maximum(data);				
		System.out.println("maximum is "+max+" which occurs at "+occurancesOfElement(data,max));
		
		Integer upperBound=new Integer(0);
		Integer lowerBound=new Integer(0);

		int[] range=range(data);
		System.out.println("lower bound = "+range[MIN]+" upper bound = "+range[MAX]);
			
		
	}
	
}
